<template>
  <div id="app">
    <v-card class="mx-3 mt-15 px-2 w-100">
      <v-row>
        <v-col
          cols="12"
          lg="4"
          md="4"
          sm="4"
          xs="12"
          class="pb-0"
          style="border: 3px solid #f4f5f6"
        >
          <div>
            <p v-if="editCondition" class="text-bold pa-3">
              Edit Data
            </p>
            <p v-else class="text-bold pa-3">
              Add Data
            </p>
            <ValidationObserver ref="form" v-slot="{ handleSubmit }">
              <v-form @submit.prevent="handleSubmit(submitForm)">
                <v-row>
                  <v-col cols="12" lg="12" md="12" sm="12" xs="12" class="pb-0">
                    <p class="app-title-small text-sm ma-0">
                      Name
                    </p>
                    <ValidationProvider
                      v-slot="{ errors }"
                      name="Name"
                      rules="required"
                    >
                      <v-text-field
                        v-model="name"
                        :error-messages="errors"
                        single-line
                        dense
                        outlined
                      ></v-text-field>
                    </ValidationProvider>
                  </v-col>
                  <v-col cols="12" lg="12" md="12" sm="12" xs="12" class="pb-0">
                    <p class="app-title-small text-sm ma-0">
                      Email
                    </p>
                    <ValidationProvider
                      v-slot="{ errors }"
                      name="Email"
                      rules="required|email"
                    >
                      <v-text-field
                        v-model="email"
                        :error-messages="errors"
                        single-line
                        dense
                        outlined
                      ></v-text-field>
                    </ValidationProvider>
                  </v-col>
                  <v-col cols="12" lg="12" md="12" sm="12" xs="12" class="pb-0">
                    <p class="app-title-small text-sm ma-0">
                      Amount
                    </p>
                    <ValidationProvider
                      v-slot="{ errors }"
                      name="Amount"
                      rules="required"
                    >
                      <v-text-field
                        v-model="amount"
                        :error-messages="errors"
                        single-line
                        dense
                        outlined
                      ></v-text-field>
                    </ValidationProvider>
                  </v-col>
                  <v-col cols="12" lg="12" md="12" sm="12" xs="12" class="pt-2">
                    <v-btn
                      type="submit"
                      color="#19abab"
                      class="text-center ma-1"
                      width="100%"
                      dark
                      :loading="loading"
                      small
                      v-if="editCondition === false"
                    >
                      <span class="text-capitalize">Add New</span>
                    </v-btn>
                    <v-btn
                      type="submit"
                      color="#3ca700"
                      class="text-center ma-1"
                      width="100%"
                      dark
                      :loading="loading"
                      small
                      v-if="editCondition === true"
                    >
                      <span class="text-capitalize">Update</span>
                    </v-btn>
                    <v-btn
                      color="#008ef8"
                      @click.prevent="closeSuccessNavigate"
                      class="text-center ma-1"
                      width="100%"
                      dark
                      text
                      small
                    >
                      <span class="text-capitalize">Cancel</span>
                    </v-btn>
                  </v-col>
                </v-row>
              </v-form>
            </ValidationObserver>
          </div>
        </v-col>
        <v-col cols="12" lg="8" md="8" sm="8" xs="12" class="pb-0">
          <div>
            <v-card-title>
              List Data
            </v-card-title>
            <v-data-table
              :headers="headers"
              :items="dataResponse"
              :items-per-page="5"
              :search="search"
              class="elevation-1"
            >
              <template v-slot:item.action="{ item }">
                <v-btn icon @click="goToEdit(item)" color="primary"
                  ><v-icon>mdi-pencil</v-icon></v-btn
                >
                <v-btn icon @click="showModalDelete(item.id)" color="#e21717"
                  ><v-icon>mdi-delete</v-icon></v-btn
                >
              </template>
            </v-data-table>
          </div>
        </v-col>
      </v-row>
    </v-card>
    <!-- modal Delete -->
    <v-dialog v-model="deleteDialog" persistent max-width="450">
      <v-card class="pa-2">
        <v-card-title class="text-blood pl-2 pt-1 pr-0 pb-3"
          >Delete Data
          <v-spacer></v-spacer>
          <v-icon
            class="float-right"
            color="grey"
            @click.prevent="deleteDialog = false"
            >mdi-close</v-icon
          >
        </v-card-title>
        <div class="text-center pa-3">
          <p class="text-blood">You Want To Delete This Data?</p>
        </div>
        <v-card-actions class="py-0 px-10">
          <v-spacer></v-spacer>
          <v-btn
            width="100%"
            rounded
            color="#F5F5F5"
            @click="deleteDialog = false"
            block
            dark
          >
            <span class="text-capitalize text-blue">Close</span>
          </v-btn>
        </v-card-actions>
        <v-card-actions class="py-0 px-10 mt-3 justify-center text-center">
          <v-btn
            :loading="loadingDel"
            @click="submitDelete"
            text
            block
            color="#F32626"
            >Yes! Delete this Data</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog success -->
    <v-dialog v-model="dialog" persistent max-width="350">
      <v-card class="pa-8 pb-10 d-flex flex-column justify-center">
        <v-icon color="green" size="100px">mdi-checkbox-marked-circle</v-icon>
        <v-card-title class="title-card mx-auto text-center"
          >{{ label }} Data <br />Success</v-card-title
        >
        <v-card-actions class="pa-0">
          <v-spacer></v-spacer>
          <v-btn
            @click.prevent="closeSuccessNavigate"
            color="green"
            :loading="loading"
            class="mt-3 w-full"
            width="100%"
            dark
          >
            <span class="text-capitalize">Okay</span>
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog failed -->
    <v-dialog v-model="dialog2" persistent max-width="350">
      <v-card class="pa-8 pb-10 d-flex flex-column justify-center">
        <v-icon color="#F32626" size="100px">mdi-alert-circle-outline</v-icon>
        <v-card-title class="title-card mx-auto text-center"
          >{{ label }} Data <br />Failed</v-card-title
        >
        <v-card-actions class="pa-0">
          <v-spacer></v-spacer>
          <v-btn
            @click.prevent="dialog2 = false"
            color="green"
            class="mt-3 w-full"
            width="100%"
            dark
          >
            <span class="text-capitalize">Okay</span>
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { createNamespacedHelpers } from "vuex";
const { mapState } = createNamespacedHelpers("master");
export default {
  name: "master",
  components: {},
  data() {
    return {
      dialog: false,
      dialog2: false,
      loading: false,
      search: null,
      name: null,
      email: null,
      amount: null,
      editCondition: false,
      actionType: null,
      deleteDialog: false,
      loadingDel: false,
      temp_id: null,
      label: null,
      headers: [
        { text: "Name", value: "name" },
        { text: "Email", value: "email" },
        { text: "Amount Count", value: "amount" },
        { text: "", value: "action" }
      ]
    };
  },
  watch: {},
  mounted() {
    this.$store.dispatch("master/getData");
  },
  computed: {
    ...mapState(["dataResponse"])
  },
  methods: {
    closeSuccessNavigate() {
      setTimeout(() => {
        this.$router.go();
      }, 200);
    },
    goToEdit(val) {
      this.name = val.name;
      this.email = val.email;
      this.amount = val.amount;
      this.$store.commit("master/SET_IDDATA", val.id);
      this.editCondition = true;
      this.$vuetify.goTo(0);
      console.log(this.temp_id);
    },
    showModalDelete(val) {
      this.deleteDialog = true;
      this.$store.commit("master/SET_IDDATA", val);
    },
    submitDelete() {
      // button effect
      this.label = "Delete";
      this.loadingDel = true;
      this.$store
        .dispatch("master/deleteData")
        .then(response => {
          const res = response.data;
          if (res.status) {
            this.deleteDialog = false;
            this.dialog = true;
            this.loadingDel = false;
          } else {
            this.deleteDialog = false;
            this.dialog2 = true;
            this.loadingDel = false;
          }
        })
        .catch(error => {
          const message = error.response.data.message;
          this.errorMessage = message;
          this.deleteDialog = false;
          this.dialog2 = true;
          this.loadingDel = false;
        });
    },
    submitForm() {
      // button effect
      if (this.editCondition === false) {
        this.actionType = "master/insertData";
        this.temp_id = null;
        this.label = "Add";
      } else {
        this.actionType = "master/updateData";
        this.label = "Update";
      }
      this.loading = true;
      this.formInput = {
        name: this.name,
        email: this.email,
        amount: this.amount
      };
      this.$store.commit("master/SET_DATA", this.formInput);
      this.$store
        .dispatch(this.actionType)
        .then(response => {
          const res = response.data;
          if (res.status) {
            this.dialog = true;
            this.loading = false;
          } else {
            this.dialog2 = true;
            this.loading = false;
          }
        })
        .catch(error => {
          const message = error.response.status.message;
          this.errorMessage = message;
          this.dialog2 = true;
          this.loading = false;
        });
    }
  }
};
</script>
